/**
 * @file          Campaign Types Form
 * @author        Mehrab Kamrani (mehrab.hassan@3ds.com)
 */
import { Form } from '../../e2elib/lib/src/pageobjects/form.component';
import { ListSOP } from '../../libappsop/listsop';
import { DialogCampaignType } from '../dialogs/dialog.campaigntype';

export class FormCampaignTypes extends Form {
  // Campaign type form with create/edit/delete and operation assignment
  public listCampaignType = new ListCampaignType();
  public constructor() {
    super('FormCampaignTypes');
  }
}

export class ListCampaignType extends ListSOP<DialogCampaignType, ListCampaignTypeColumn> {
  public readonly name = 'Campaign Types';

  public constructor() {
    super('ListCampaignType', new DialogCampaignType());

    // Set primary key column name(s), to display in error message when assert fails
    this.rowPrimaryColumnNames = { Name: '' };
    this.rowAllConstraintsColumnName = { 'All constraints': '' };
  }
}

export interface ListCampaignTypeColumn {
  'All constraints'?: string;
  Name?: string;
  Unit?: string;
  'Default Min'?: string;
  'Default Max'?: string;
}

const listCampaignTypeContextMenuItem = {
  Create: { ContextMenu: 'listContextMenuCampaignType', Name: 'MenuCreate', Label: 'Create' },
  Edit: { ContextMenu: 'listContextMenuCampaignType', Name: 'MenuEdit', Label: 'Edit' },
  Delete: { ContextMenu: 'listContextMenuCampaignType', Name: 'MenuDelete', Label: 'Delete' },
};

export { listCampaignTypeContextMenuItem as ListCampaignTypeContextMenuItem };
